/*	MIRS9805
 *	defs.h	: Defines for MIRS9805 Tasks
 *	Version	0.15
 *	by Kento 99/06/22
 *
 *	History
 *	0.14 99/07/17	PWM,RE ֌W̒萔ǉ
 *	0.13 99/07/15	ovl^C}^XN̎ added
 *	0.12 99/07/14	^b`ZT̒萔 added
 *	0.11 99/07/13	EOM added
 *	0.10 99/07/13	MACROs added
 *	0.09 99/07/10	priority changed
 *	0.08 99/06/30	MACROs added
 *	0.07 99/06/29	USS channel number added
 *	0.06 99/06/25	'table.h'  include ȂBBB_MAX,MAXTSK ǉ
 *	0.05 99/06/25	ABS,BIT_R,BIT_W ̃}Nǉ
 *	0.04 99/06/22	'table.h'  include
 *	0.03 99/06/18	True & Flase ǉ
 *	0.02 99/06/18	ԈႢC
 *	0.01 99/06/18	
 */

#define MAXTSK 13	/* the number of task */
#define BB_MAX 10	/* the number of BB */

#define TIMER_MMI 10	/* Time interval of MMI timer task */
#define TIMER_RE  3	/* Time interval of RE timer task */
#define TIMER_PWM 3	/* Time interval of PWM timer task */
#define TIMER_IRS 5	/* Time interval of IRS timer task */
#define TIMER_SHU 10	/* Time interval of ȈʒuC timer task */

#define PY_MMI	2	/* Priority of MMI task */
#define PY_USS	3	/* Priority of USS task */
#define PY_JIK	3	/* Priority of Ȉʒuo task */
#define PY_PWM	1	/* Priority of PWM task */
#define PY_KOU	6	/* Priority of sv task */
#define PY_SHU	2	/* Priority of ȈʒuC task */
#define PY_TRC	4	/* Priority of OgX task */
#define PY_TST	5	/* Priority of s task */
#define PY_KAK	4	/* Priority of lA task */
#define PY_KID	6	/* Priority of O task */

#define TRUE	1	/* True */
#define FALSE	0	/* False */

#define USS0	0	/* USS channel #0 (right)*/
#define USS1	1	/* USS channel #1 (front)*/
#define USS2	2	/* USS channel #2 (left)*/
#define USS3	3	/* USS channel #3 (back)*/

#define TSR	0	/* Touch sensor Right */
#define TSF	1	/* Touch sensor Front */
#define TSL	2	/* Touch sensor Left */


#define EOM	999	/* End of Map	*/

#define PI	3.14159265359f	/* Pai ()	*/
#define PI2	(PI*2.f)	/* 2		*/
#define PIH	(PI/2.f)	/* /2		*/

#define DT	0.03f		/* task02 period[sec] */
#define D	0.0715f		/* diameter of tyre[m] 			*/
#define RG	16.0f		/* Gear ratio 				*/
#define PPR	400.0f	     	/* pulse every revolution [pulse/r] 	*/

#define COEF	((PIH*D)/(PPR*RG*DT))	/* w/pulse			*/


/* These MACROs are programmed by Kento. (^.^(^^(^o^(^O^)^o^)^^)^.^) */

#define ABS(x)		((x<0)?-x:x)		/* Βl 		     */
#define BIT_R(x,y) 	((x>>y)&1)		/* x  y bitڂ bit Ԃ */
#define BIT_W(x,y,z)	x=(((z&1)==0)?(x&(-1-(1<<y))):(x|(1<<y))) 
						/* x  y bitڂ z ɂ   */

#define SET_VAL(x,y,z)	*((int *)sys9(x,y))=z	/* *(BB(x,y))  z */
#define DISP_SET(x,y)	SET_VAL(0,x,y)		/* MMILED\Zbg*/
#define LED_SET(x)	SET_VAL(0,6,x)		/* MMIRGLED_Zbg*/
#define GET_VAL(x,y)	*((int *)sys9(x,y))	/* *(BB(x,y)) 𓾂*/
#define LED_GET()	GET_VAL(0,6)		/* MMILED\擾*/


/* -------------------------------------------------------------------- */


/* end of file (^_^)v */
