/****************************************************/
/* HardWare Function library head file              */
/*				ver1.0 Oct. 15 1996 */
/*                                 1.1 Nov. 24 1996 */
/*                                        N.Hayashi */
/*			  ver.1.2  Nov. 26 1997     */
/*                        ver.2.0  Jan. 17 1998     */
/*                        ver.2.1  Feb. 18 1998     */
/*                        ver.2.2  Mar. 25 1998     */
/****************************************************/
/* MIRS9805 hard.h	Customized by Kento (99/06/27)*/
/*	History:	led_set_all_h() added	      */
/*					   	      */
/*						      */
/******************************************************/ 

/* interrupt vector */
#define BTN_INT_VCT	 3
#define USS_INT_VCT	72
#define IRS_INT_VCT	74
#define TS_INT_VCT	76

/* rotary encoder and touch sensor data type */
typedef struct {
	int r;
	int l;
	int ts;
}RE_TS_DATA;

/* led */
#define GREEN	0x01
#define RED	0x02
#define OFF	0

/* infrared sensor functions --------------------------------------- */
extern void		irs_init(int);		/* initialize                */
extern void		irs_disable_int();	/* interrupt disable         */
extern void		irs_enable_int();	/* interrupt enable          */
extern int		irs_data();		/* read infrared sensor data */
/* rotary encoder and touch sensor functions ------------------------ */
extern void		re_ts_init();		/* initialize                */
extern void		re_counter_reset();	/* RE counter reset          */
extern RE_TS_DATA	re_ts_data();		/* read RE and TS data       */
extern int		ts_data();		/* read touch sensor data    */
extern void		ts_disable_int();	/* interrupt disable         */
extern void		ts_enable_int();	/* interrupt enable          */
/* ultra sound sensor functions ------------------------------------ */
extern void		uss_init();		/* initialize                */
extern void		uss_start(int);		/* sending sonic             */
extern void		uss_stop();		/* stop waitting interrupt   */
extern int		uss_data();		/* calculate distans         */
extern int		uss_chk_int();		/* check interrupt type      */
extern int		uss_chk_conect();       /* check conect sensor       */
/* pwm functions --------------------------------------------------- */
extern void		pwm_init();		/* initialize                */
extern void		pwm_data(int,int);	/* output data to pwm        */
/* mmi functions --------------------------------------------------- */
extern int		dipsw_data();		/* read dip switch           */
extern void		mmi_init();		/* initialize                */
extern void		led_set(int,int);	/* set data to 7seg. and LED */
extern void		led_on(int);		/* green and red led on      */
extern void		btn_disable_int();	/* interrupt disable         */
extern void		btn_enable_int();	/* interrupt enable          */
extern int		pow_chk();		/* check power               */
extern void		led_set_all(int);
extern void		led_set_all_h(int);
extern void		led_set_3(int);
extern int		inportb();
extern int		outportb();
extern int		outportl();
extern void		rs_init();
extern void 		rs_snd();
extern void		rs_rcv();
extern int		recvi();
extern float 		recvf();
extern void 		iprint(int,int);
extern void 		iprint_h(int,int);
extern void		uprint(unsigned,int,int);
extern void 		fprint(float,int);
extern void 		print_space(int);
extern void 		rs_putc(char);

#define Z_SPEED	0
#define L_SPEED 30
#define M_SPEED	60
#define H_SPEED 100
/* - end - (^^; */