/*	MIRS9805
 *	Task00	: Man-Machine Interface Task
 *	Version	0.07	(99/07/02)
 *	by Kento 99/06/18
 *
 *	History
 *	0.07 99/07/02	_ŃXs[hύXA\POiɁB̑XB
 *	0.06 99/07/02	Bug fixed
 *	0.05 99/06/30	tO̐ݒ@ύXB
 *	0.04 99/06/27	\f[^̊i[@ύXBR}h폜B
 *	0.03 99/06/25	LED_̏CBR}hǉB
 *	0.02 99/06/22	Rg̏C
 *	0.01 99/06/18	First version
 */

#include "mirx68k.h"		/* MIRX68K header file 			*/
#include "hard.h"		/* Hardware function library header file*/
#include "defs.h"		/* MIRS9805 defination header file 	*/

#define BLK_TIM 1		/* time interval for blinking 		*/
#define MY_BB 4			/* number of my BB for display 		*/

static int bb_num;		/* Number of BB for display 		*/
static int led_status;		/* status of R&G LED 			*/
static int r_flag;		/* rotation flag 			*/
static int p_flag;		/* push switch flag 			*/
static int pf;			/* push switch flag (old)		*/
static int tmr;			/* blinking timer 			*/
static int p_count;		/* times of pushed 			*/
static int disp_data[MY_BB];	/* data for dispaly			*/

void inzt00(){				/* initialization */
	int i;
	sys0(0,0x1111);			/* register this task */
	
	mmi_init();			/* Initialize MMI */

	sys8(0,0,(int)disp_data);	/* pointer of Data for display 1 */
	sys8(0,1,(int)(disp_data+1));	/* pointer of Data for display 2 */
	sys8(0,2,(int)(disp_data+2));	/* pointer of Data for display 3 */
	sys8(0,3,(int)(disp_data+3));	/* pointer of Data for display 4 */
	sys8(0,4,(int)(&bb_num));	/* pointer of # of BB for Display*/
	sys8(0,5,(int)(&r_flag));	/* pointer of Rotation's flag 	 */
	sys8(0,6,(int)(&led_status));	/* pointer of Status of R&G LED	 */
	sys8(0,7,(int)(&p_flag));	/* pointer of Push switch's flag */
	sys8(0,8,0);			/* Value of Rotary switch 	 */
	sys8(0,9,0);			/* TIMES of button Pushed 	 */
	
	sys2(0,TIMER_MMI,0,0);		/* Set timer task */
	sys5(0,1,BTN_INT_VCT,0,0);	/* Set interrupt task */
	btn_disable_int();		/* disable interruption of the button*/

	bb_num=0;			/* init variables */
	led_status=0;			/* init variables */
	r_flag=0;			/* init variables */
	p_flag=pf=0;			/* init variables */
	tmr=0;				/* init variables */
	p_count=0;			/* init variables */
	for(i=0;i<MY_BB;i++)		/* init variables */
		disp_data[i]=0;
}

void nrmt00(int cm, int scm){
	switch (cm){
		case 1:	bb_num=scm;		/* \BB̐ݒ */
			break;
		case 2:	led_status=scm;		/* R&G LED ̐ݒ */
			break;
		case 3:	r_flag=scm;		/* Rotation flag ̐ݒ */
			break;
		case 4:	p_flag=scm;		/* Push switch flag ̐ݒ */
			break;
		default:
			break;
	}
}
void timt00(int cm, int scm){
	int dip;				/* dipsw */
	int val;				/* value for display */
	int tn,bbn;				/* task number,bb number */
	int led;				/* LED data */
	
	tmr=0;
/*	tmr++;			*/		/* increase blinking timer */
/*	if(tmr>=BLK_TIM){	*/		/* if max  */
/*		tmr=0;		*/		/* then zero */
/*	}			*/
	if(p_flag!=pf){
		if(p_flag==TRUE){
			btn_enable_int();	/* enable init */
		} else {
			btn_disable_int();	/* disable init */
		}
		pf=p_flag;
	}
	if(bb_num<MY_BB){			/* ̃^XNBB */
		val = disp_data[bb_num];	/* read value from BB(bb_num)*/
		led_set_all(val);		/* display val to LED */
	/*	led_set_all_h(val);	*/	/* display val to LED */
	} else {				/* BB̕\ */
		tn=bb_num/BB_MAX;		/* number of TASK */
		bbn=bb_num%BB_MAX;		/* number of BB */
		if(tn>=MAXTSK)			/* if tn is too big */
			tn=0;			/* tn=0 */
		val = sys9(tn,bbn);		/* read value from BB(bb_num)*/
	/*	led_set_all_h(val);	*/	/* display val to LED */
		led_set_all(val);		/* display val to LED */
	}
	
	led=OFF;				/* led initialize */
	if((led_status & 0x11) == 0){		/* if both R&G LED are off */
	} else {				/* else */
		if((led_status & 0x01)!=0){	/* RED LED on */
			if((led_status & 0x02)!=0){	/* if blinking */
				if((led_status & 0x04)!=0){	/*  */
					if(tmr==0)
						led_status &= 0xfb;/* _ */
				}else {
					led= led | RED;		/* _ */
					if(tmr==0)
						led_status |= 0x04;/*  */
				}
			}else {					/* not blink */
				led=led | RED;			/* RED _ */
			}
		}
		if((led_status & 0x10)!=0){			/* G LED on */
			if((led_status & 0x20)!=0){		/* if blink */
				if((led_status & 0x40)!=0){	/*  */
					if(tmr==0)
						led_status &= 0xbf;/* _ */
				}else {
					led= led | GREEN;	/* _ */
					if(tmr==0)
						led_status |= 0x40;/*  */
				}
			}else {					/* not blink */
				led=led | GREEN;		/* G LED _*/
			}
		}
	}
	led_on(led);
	
	dip=dipsw_data();			/* read value of dipsw */
	sys8(0,8,dip);				/* write dip into BB */
}
interrupt void intt00(){
	int min,max;
	btn_disable_int();
	p_count++;				/* count up p_count */
	sys8(0,9,p_count);			/* write p_count into BB */
	if(r_flag==TRUE){			/* if rotation flag set */
		if(bb_num<MY_BB){		/* if bb_num<MY_BB */
			bb_num++;		/* increase bb_num */
			if(bb_num>=MY_BB)	/* rotation */
				bb_num=0;	/* */
		}else{				/* else */
			bb_num++;		/* increase */
			min=disp_data[0];	/* read min */
			max=disp_data[1];	/* read max */
			if(max>=MAXTSK*BB_MAX)/* normalize */
				max=MAXTSK*BB_MAX-1;
			if(min<0 || min>=max){	/* normalize */
				min=MY_BB;	/*  */
				max=MAXTSK*BB_MAX-1;
			}
			if(bb_num>max){		/* rotation */
				bb_num=min;	/* */
			}
		}
	}
	btn_enable_int();
}


/* end of file 'tasc00.c' (Q_Q) */
