/*	MIRS9805
 *	Task06	: corection self location Task
 *	Version	0.08	(99/08/23)
 *	by Kento 99/07/12
 *	
 *	History
 *	0.08 99/07/23	]Ɉx~܂
 *	0.07 99/07/20	Beta version
 *	0.06 99/07/18	낢ƕύXB
 *	0.05 99/07/17	Ẽf[eB[̊ԈႢ
 *	0.04 99/07/15	f[eB蕔̏C
 *	0.03 99/07/14	̐(ꉞ_IɓBŎۂɂ͎gȂ)
 *	0.02 99/07/13	Bug fixed version
 *	0.01 99/07/12	First version
 */

#include <math.h>

#include "mirx68k.h"		/* MIRX68K header file */
#include "hard.h"		/* Hardware function library header file */
#include "defs.h"		/* MIRS9805 defination header file */

#define E	3		/* e덷[cm]	*/
#define ET	2		/* e덷[deg]*/
#define ET2	2		/* e덷[deg]*/
#define DEG(x)	(x/PI*180.0f)	/* rad to deg	*/

#define R	0
#define L	1

#define STOP_COUNT 12

float my_atan2(float a,float b);	/* atan of (b/a). return [-pi:pi] */

static int turning_flag=FALSE;
static int corect_flag=FALSE;		/* corection flag */
static int end_flag=TRUE;		/* corection end flag */
static int t_x=0;			/* target x	*/
static int t_y=0;			/* target y	*/
static int t_th=0;			/* target theta	*/
static int type_cm=0;			/* type of corection	*/
static int type_cm_old=0;		/* old type of corection*/
static int stop_flag=0;
static int stop_count=0;
static int pdd[2]={0,0};
static int pd[2]={0,0};
static int pw[2]={0,0};
static float param[2][6]={{50,25,15,60,80,5},{50,25,15,60,80,5}};
	/* imax maxɂȂ鋗 imin pxmax maxɂȂpx pxmin */
static int pwm_limit[2]={80,80};

void inzt06(){				/* initialization */
	sys0(6,0x1110);			/* register this task */

	sys8(6,0,(unsigned int)&corect_flag);	/* pointer of crection flag */
	sys8(6,1,t_x);			/* ڕWWf[^ */
	sys8(6,2,t_y);			/* ڕWWf[^ */
	sys8(6,3,t_th);			/* ڕWpxf[^ */
	sys8(6,4,end_flag);			/* End flag */
	sys8(6,5,0);			/* Not used */
	sys8(6,6,0);			/* Not used */
	sys8(6,7,0);			/* Not used */
	sys8(6,8,0);			/* Not used */
	sys8(6,9,0);			/* Not used */

	sys2(6,TIMER_SHU,0,0);		/* regist timer task	*/

	corect_flag=FALSE;			/* initialize variables */
	t_x=0;				/* initialize variables */
	t_y=0;				/* initialize variables */
	t_th=0;				/* initialize variables */
	turning_flag=FALSE;
	stop_flag=0;
	stop_count=0;
}
 
void nrmt06(int cm, int scm){
	float theta;
	type_cm_old=type_cm;			/* save type_cm */
	switch (cm){
		case 1:	corect_flag=scm;	/* corect flag ݒ */
			break;
		case 2:	t_x=scm;		/* ڕWW̐ݒ */
			sys8(6,1,t_x); 		/* write t_x into BB */
			type_cm=1;
			break;
		case 3:	t_y=scm;		/* ڕWW̐ݒ */
			sys8(6,2,t_y);		/* write t_y into BB */
			type_cm=1;
			break;
		case 4:	t_x=*((int *)scm);	/* ڕW(x,y)W̐ݒ */
			t_y=*((int *)scm+1);
			sys8(6,2,t_y);		/* write t_y into BB */
			sys8(6,1,t_x); 		/* write t_x into BB */
			type_cm=1;
			corect_flag=TRUE;
			turning_flag=FALSE;
			break;
		case 5:	t_th=scm;		/* ڕWpx̐ݒ */
			while(t_th>360){
				t_th-=360;
			}
			while(t_th<0){
				t_th+=360;
			}
			sys8(6,3,t_th);		/* write t_th into BB */
			type_cm=2;
			corect_flag=TRUE;
			break;
		case 6:	theta=(float)(sys9(2,2))*PI/180.0f;/* [rad] ɒ	*/
			while(theta>PI2){
				theta-=PI2;
			}
			while(theta<0){
				theta+=PI2;
			}
			t_x=sys9(2,0)+(int)(sinf(theta)*scm);/* ڕWʒu*/
			t_y=sys9(2,1)-(int)(cosf(theta)*scm);/* vZ	*/
			sys8(6,2,t_y);		/* write t_y into BB */
			sys8(6,1,t_x); 		/* write t_x into BB */
			type_cm=1;
			corect_flag=TRUE;
			break;
		case 7:	t_x=*((int *)scm);/* 4Ɠ(ɊpxC) */
			t_y=*((int *)scm+1);
			sys8(6,2,t_y);		/* write t_y into BB */
			sys8(6,1,t_x); 		/* write t_x into BB */
			type_cm=1;
			corect_flag=TRUE;
			turning_flag=TRUE;
			break;
		default:
			break;
	}
	if(type_cm!=type_cm_old){
		if(type_cm!=4){
			stop_flag=TRUE;		/* stop flag */
		}
	}
	end_flag=FALSE;
	sys8(6,4,end_flag);
}


void timt06(int cm, int scm){
	int x,y;
	int th;
	int a,b,c,d,e,fx,g,h;
	float theta;
	float tt,aa,bb;
	int i;
	int dd[2];
	int dflag=0;
	int type_cm2;

	if(corect_flag==TRUE){
		x=sys9(2,0);			/* Ȉʒu擾	*/
		y=sys9(2,1);
		th=sys9(2,2);
		if(stop_flag==TRUE){
			type_cm2=type_cm;
			type_cm=-1;
			pw[R]=pw[L]=0;
			sys1(4,PY_PWM,6,(int)pw);/* [^~	*/
		}
		if(type_cm==1){			/* WC	*/
			a=t_x-x;
			b=t_y-y;
			c=ABS(a);
			d=ABS(b);
			fx=sqrt(a*a+b*b);
			if((fx<=E)){		/* e덷ȂCI */
				type_cm=0;
			}
			theta=my_atan2(-b,a);	/* px */
			if(theta<0){		/* pxȂ */
				theta+=PI2;
			}
			e=(int)DEG(theta);	/* deg -> rad */
			h=e;
			e-=th;			/* ppxƖړInpƂ̍ */
			if(e>180){
				e-=360;
			}else if(e<-180){
				e+=360;
			}
			g=ABS(e);
			
			for(i=0;i<2;i++){
				pd[i]=0;
				pdd[i]=0;
				if(g<param[i][4]){	/* px */
					pdd[i]=(int)((param[i][3])*e/180.0f);
				} else {
					if(e>0){
						pdd[i]=param[i][3];
					}else if(e<0){
						pdd[i]=-param[i][3];
					}
				}
				if((ABS(pdd[i])<param[i][5])){
					if(pdd[i]<0){
						pdd[i]=-param[i][5];
					}else if(pdd[i]>0){
						pdd[i]=param[i][5];
					}
				}
				if(turning_flag==FALSE){	/* x */
					if(fx<param[i][1]){
						pd[i]=(int)(param[i][0]/param[i][1]*fx);
					}else{
						pd[i]=(int)(param[i][0]);
					}
					if((fx!=0) && (ABS(pd[i])<param[i][2])){
						pd[i]=param[i][2];
					}
				}
			}
			if(turning_flag==TRUE){
				if(g<=ET){
					turning_flag=FALSE;
					stop_flag=TRUE;
				}
			}
			pw[R]=pd[R]+pdd[R];		/* Eduty */
			pw[L]=pd[L]-pdd[L];		/* duty */
			for(i=0;i<2;i++){		/* duty  limit */
				if(pw[i]>pwm_limit[i]){
					dd[i]=pw[i]-pwm_limit[i];
					dflag=1;
				}else if(pw[i]<-pwm_limit[i]){
					dd[i]=pw[i]+pwm_limit[i];
					dflag=1;
				}
			}
			if(dflag==1){			/* duty>limit Ȃ */
				if(ABS(dd[R])>ABS(dd[L])){
					pd[R]-=dd[R];	/* xJbg */
					pd[L]-=dd[R];
				}else{
					pd[R]-=dd[L];
					pd[L]-=dd[L];
				}
				pw[R]=pd[R]+pdd[R];
				pw[L]=pd[L]-pdd[L];
			}
			pw[L]=-pw[L];			/* ̓}CiX */
			sys1(4,PY_PWM,6,(int)pw);/* w */
		} else if(type_cm==2){		/* ppC	*/
			e=t_th-th;
			if(e>180){
				e-=360;
			}else if(e<-180){
				e+=360;
			}
			g=ABS(e);
			if(g<=ET){		/* e덷ȂCI */
				type_cm=0;
				pd[R]=pd[L]=0;
			}
				
			for(i=0;i<2;i++){
				pd[i]=0;
				pdd[i]=0;
				if(g<param[i][4]){	/* px */
					pdd[i]=(int)((param[i][3])*e/180.0f);
				} else {
					if(e>0){
						pdd[i]=param[i][3];
					}else if(e<0){
						pdd[i]=-param[i][3];
					}
				}
				if((ABS(pdd[i])<param[i][5])){
					if(pdd[i]<0){
						pdd[i]=-param[i][5];
					}else if(pdd[i]>0){
						pdd[i]=param[i][5];
					}
				}
			}
			pw[R]=pdd[R];
			pw[L]=-pdd[L];
			
			pw[L]=-pw[L];
			
			sys1(4,PY_PWM,6,(int)pw);/* w */
		}
		if(type_cm==0){			/* CI */
			pw[R]=pw[L]=0;
			sys1(4,PY_PWM,6,(int)pw);/* [^~	*/
			end_flag=TRUE;
			corect_flag=FALSE;
			sys8(6,4,end_flag);
		}
		if(type_cm==-1){
			type_cm=type_cm2;
			stop_count++;
			if(stop_count>STOP_COUNT){
				stop_count=0;
				stop_flag=FALSE;
			}
		}
	}else{
		end_flag=TRUE;
		sys8(6,4,end_flag);
	}
}

float my_atan2(float a,float b){	/* atan of b/a return [-pi:pi] */
	float theta;
	if(b==0){
		if(a>=0){
			theta=0;
		}else{
			theta=PI;
		}
	}else if(a==0){
		if(b>0){
			theta=PIH;
		}else{
			theta=-PIH;
		}
	}else{
		theta=atan((b/a));
		if((b>0) && (theta<0)){
			theta+=PI;
		}
		if((b<0) &&(theta>0)){
			theta-=PI;
		}
	}
	return theta;
}
interrupt void intt06(){
}

/* end of file 'tasc06.c' (*_*) */
